#include <test_MeshDataBase.hpp>
#include <utils/PugsAssert.hpp>

#include <mesh/CartesianMeshBuilder.hpp>

const test_MeshDataBase* test_MeshDataBase::m_instance = nullptr;

test_MeshDataBase::test_MeshDataBase()
{
  std::make_shared<CartesianMeshBuilder>(TinyVector<3>{0, 1, 0}, TinyVector<3>{2, -1, 3},
                                         TinyVector<3, size_t>{6, 7, 3});
}

const test_MeshDataBase&
test_MeshDataBase::get()
{
  return *m_instance;
}

void
test_MeshDataBase::create()
{
  Assert(m_instance == nullptr);
  m_instance = new test_MeshDataBase();
}

void
test_MeshDataBase::destroy()
{
  Assert(m_instance != nullptr);
  delete m_instance;
  m_instance = nullptr;
}
